package enumtest;

import javax.persistence.EntityManager;
import javax.persistence.Persistence;
import org.junit.BeforeClass;
import org.junit.Test;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseBuilder;
import org.springframework.jdbc.datasource.embedded.EmbeddedDatabaseType;
import org.springframework.test.context.ContextConfiguration;

@ContextConfiguration("context.xml")
public class EnumTest {

    private static EntityManager em = Persistence.createEntityManagerFactory("testPU").createEntityManager();

    @BeforeClass
    public static void setUp() throws Exception {
        new EmbeddedDatabaseBuilder().setType(EmbeddedDatabaseType.HSQL).setName("testDB").addScript("ddl.sql").build();
    }

    @Test
    public void testMoneyMapping() {
        em.getTransaction().begin();
        TestEntity testEntity = new TestEntity(null, new TestEmbed("test", TestEnum.TEST_ENUM_1));
        em.persist(testEntity);
        em.flush();
        Long id = testEntity.getId();
        em.clear();
        em.find(TestEntity.class, id);
        em.getTransaction().commit();
    }
}
